package com.nisum.clients;

import com.nisum.constants.Constants;
import com.nisum.utils.Utils;
import lombok.extern.slf4j.Slf4j;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.simple.JSONObject;
import org.json.simple.parser.ParseException;
import org.springframework.beans.factory.annotation.Autowired;

import java.io.IOException;
import java.net.URL;


@Slf4j
public class HttpClient {

    private static final org.slf4j.Logger logger =
            org.slf4j.LoggerFactory.getLogger(HttpClient.class);

    @Autowired
    Utils utils;



    //Using HTTP (Method 2)
    public void getUsingHttpClient() throws IOException, ParseException {

        try {
            DefaultHttpClient httpClient = new DefaultHttpClient();
            HttpGet getRequest = new HttpGet(Constants.URL_EMPLOYEES);
            getRequest.addHeader("accept", "application/json");
            HttpResponse response = httpClient.execute(getRequest);

            if (response.getStatusLine().getStatusCode() != 200) {
                throw new RuntimeException("Failed : HTTP error code : "
                        + response.getStatusLine().getStatusCode());
            } else {

                int i = 0;
                JSONObject obj = null;
                do {
                    if (i == 0) {
                        System.out.println(response);
                        obj = utils.getJsonObjectHttp(response, 0);
                        utils.saveInFile(obj, i);
                    } else {
                        URL url = new URL(obj.get("next").toString());
                        HttpGet getRequestNew = new HttpGet(url.toString());
                        getRequestNew.addHeader("accept", "application/json");
                        HttpResponse responseNew = httpClient.execute(getRequestNew);
                        JSONObject objnew = utils.getJsonObjectHttp(responseNew, i);
                        utils.saveInFile(objnew, i);
                        obj = objnew;
                    }
                    i++;

                } while (i <= Constants.no_of_pages - 1);
                httpClient.getConnectionManager().shutdown();
            }
        }
        catch(RuntimeException e){
            logger.info("RuntimeException "+e.getStackTrace());
        }
    }







}
