package com.nisum.clients;

import com.nisum.constants.Constants;
import com.nisum.utils.Utils;
import lombok.extern.slf4j.Slf4j;
import org.json.simple.JSONObject;
import org.json.simple.parser.ParseException;
import org.springframework.beans.factory.annotation.Autowired;

import java.io.IOException;


@Slf4j
public class RestTemplateClient {

    private static final org.slf4j.Logger logger =
            org.slf4j.LoggerFactory.getLogger(HttpClient.class);

    @Autowired
    Utils utils;

    //using Spring Rest Template(Method 1)
    public void getUsingRestTemplate()  {
        try {
            int i = 0;
            JSONObject obj = null;
            do {
                if (i == 0) {
                    obj = utils.getJSONObject(Constants.URL_EMPLOYEES);
                    utils.saveInFile(obj, 0);
                } else {
                    JSONObject objnew = utils.getJSONObject(obj.get("next").toString());
                    utils.saveInFile(objnew, i);
                    obj = objnew;
                }
                i++;
            } while (i <= Constants.no_of_pages - 1);
        }
        catch(ParseException e){
            logger.info("ParseException "+e.getStackTrace());
        }
        catch(IOException ex){
            logger.info("IOException "+ex.getStackTrace());
        }
    }




}
