package com.nisum.utils;

import org.apache.http.HttpResponse;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import org.json.simple.parser.ParseException;
import org.springframework.context.annotation.Bean;
import org.springframework.web.client.RestTemplate;

import java.io.*;

public class Utils {

    @Bean
    public RestTemplate getRestTemplate() {
        return new RestTemplate();
    }

    //Method to get a json object from the content of a get call when using httpClient
    public JSONObject getJsonObjectHttp(HttpResponse response, int i) throws IOException, ParseException {
        BufferedReader br = new BufferedReader(new InputStreamReader((response.getEntity().getContent())));
        String output;
        output=br.readLine();
        JSONParser parser = new JSONParser();
        JSONObject obj = (JSONObject) parser.parse(output);
        return obj;
    }

    //Method to get a json object from the content of a get call when using rest template
    public JSONObject getJSONObject(String URL) throws ParseException {
        String result = getRestTemplate().getForObject(URL, String.class);
        JSONParser parser = new JSONParser();
        JSONObject obj = (JSONObject) parser.parse(result);
        return obj;
    }

    //Method to save the json object to different files with data of each page in separate file
    public void saveInFile(JSONObject jsonObject, int i) throws IOException {
        BufferedWriter writer = new BufferedWriter(new FileWriter("D:\\Backup Folder\\hateoas" + (i + 1) + ".json"));
        writer.newLine();
        writer.write(jsonObject.toString());
        writer.close();
    }
}
